package com.yhy.module.core.service.boq;

import com.yhy.module.core.controller.admin.boq.vo.BoqItemTreeRespVO;
import com.yhy.module.core.controller.admin.boq.vo.BoqItemTreeSaveReqVO;
import com.yhy.module.core.controller.admin.boq.vo.BoqItemTreeSwapSortReqVO;

import javax.validation.Valid;
import java.util.List;

/**
 * 清单项树 Service 接口
 *
 * @author yhy
 */
public interface BoqItemTreeService {

    /**
     * 创建清单项树节点
     *
     * @param createReqVO 创建信息
     * @return 节点ID
     */
    Long createBoqItemTree(@Valid BoqItemTreeSaveReqVO createReqVO);

    /**
     * 更新清单项树节点
     *
     * @param updateReqVO 更新信息
     */
    void updateBoqItemTree(@Valid BoqItemTreeSaveReqVO updateReqVO);

    /**
     * 删除清单项树节点
     *
     * @param id 节点ID
     */
    void deleteBoqItemTree(Long id);

    /**
     * 获取清单项树节点
     *
     * @param id 节点ID
     * @return 节点信息
     */
    BoqItemTreeRespVO getBoqItemTree(Long id);

    /**
     * 获取清单项树（树形结构）
     *
     * @param boqCatalogItemId 清单专业ID
     * @return 树形结构
     */
    List<BoqItemTreeRespVO> getBoqItemTreeTree(Long boqCatalogItemId);

    /**
     * 获取清单项树列表
     *
     * @param boqCatalogItemId 清单专业ID
     * @return 列表
     */
    List<BoqItemTreeRespVO> getBoqItemTreeList(Long boqCatalogItemId);

    /**
     * 交换排序
     *
     * @param swapReqVO 交换信息
     */
    void swapSort(@Valid BoqItemTreeSwapSortReqVO swapReqVO);
}
